package com.example.ozekivoipservicechecker;

import hu.ozeki.ozekivoipservicechecker.R;

import java.io.UnsupportedEncodingException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Enumeration;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.http.conn.util.InetAddressUtils;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.graphics.Point;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.Display;
import android.view.View;
import android.view.WindowManager;
import android.widget.EditText;

public class MainActivity extends Activity {
	
	public final static String EXTRA_DATA = "";
	
	public static int height = 0;
	public static int width = 0;
    public static int cseq = 1;
	public static String username = new String();
	public static String auth = new String();
	public static String password = new String();
	public static String pbx = new String();

    /** Resolution HEIGHT and WIDTH */
    @SuppressLint("NewApi")
	@SuppressWarnings("deprecation")
	public int[] height() {
    	int[] result = new int[2];

    	int Measuredwidth = 0;
    	int Measuredheight = 0;

    	Point size = new Point();
    	WindowManager w = getWindowManager();

    	// If the Android version is Honeycomb or higher
    	if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB) {
    		w.getDefaultDisplay().getSize(size);
    		Measuredwidth = size.x;
    	    Measuredheight = size.y;
    	}
    	// If the Android version is smaller than Honeycomb
    	else {
    		Display d = w.getDefaultDisplay();
    	    Measuredwidth = d.getWidth();
    	    Measuredheight = d.getHeight();
    	}

    	result[0] = Measuredheight;
    	result[1] = Measuredwidth;

		return result;
    }

	/** MD5 */
    public String getMD5Digest(byte[] buffer) {
    	String resultHash = null;
        try {
            MessageDigest md5 = MessageDigest.getInstance("MD5");

            byte[] result = new byte[md5.getDigestLength()];
            md5.reset();
            md5.update(buffer);
            result = md5.digest();

            StringBuffer buf = new StringBuffer(result.length * 2);

            for (int i = 0; i < result.length; i++) {
                int intVal = result[i] & 0xff;
                if (intVal < 0x10) buf.append("0");
                buf.append(Integer.toHexString(intVal));
            }
            resultHash = buf.toString();
        }
        catch (NoSuchAlgorithmException e) {
        }
        return resultHash;
    }

    /** Local IP */
    public String getLocalIpAddress() {
        try {
            for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
                NetworkInterface intf = en.nextElement();
                for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
                    InetAddress inetAddress = enumIpAddr.nextElement();
                    System.out.println("ip1--:" + inetAddress);
                    System.out.println("ip2--:" + inetAddress.getHostAddress());

		            String ipv4;
		            // for getting IPV4 format
		            if (!inetAddress.isLoopbackAddress() && InetAddressUtils.isIPv4Address(ipv4 = inetAddress.getHostAddress())) {
		            	return ipv4;
                    }
                }
            }
        } 
        catch (Exception ex) {
            Log.e("IP Address", ex.toString());
        }
        return null;
    }

    /** String generator */
    public String randomString(int len) {
    	String ab = "0123456789abcdefghijklmnopqrstuvwxyz";
        Random rnd = new Random();
        StringBuilder sb = new StringBuilder(len);
        for(int i = 0; i < len; i++) 
           sb.append(ab.charAt (rnd.nextInt(ab.length())));
        return sb.toString();
    }

    /** Get values between two string */
    public String getValues(String str, String start, String end) {
    	Pattern pattern = Pattern.compile("" + start + "(.*?)"+end+"");
		Matcher matcher = pattern.matcher(str);
		StringBuffer result = new StringBuffer();
		if (matcher.find())
			result.append(matcher.group(1));
		StringBuffer sbuf = new StringBuffer(result);
		return sbuf.toString();
    }

    /** Register Message 
     * @throws UnsupportedEncodingException */
    public byte[] registerMsg(String sipProviderhost, String mylocalIp, String branch, String userName, String tag, int cseq, String callid) throws UnsupportedEncodingException {
        String message = "REGISTER sip:" + sipProviderhost + ":5060 SIP/2.0\r\n"
                + "Via:SIP/2.0/UDP " + mylocalIp + ":5780;branch=" + branch + ";rport\r\n"
                + "To: <sip:" + userName + "@" + sipProviderhost + ":5060>\r\n"
                + "From: <sip:" + userName + "@" + sipProviderhost + ":5060>;tag=" + tag + "\r\n"
                + "Call-ID: " + callid + "\r\n"
                + "CSeq: " + cseq + " REGISTER\r\n"
                + "Contact: <sip:" + userName + "@" + mylocalIp + ":5780>\r\n"
                + "Expires: 3600\r\n"
                + "Supported: 100rel\r\n"
                + "Allow: INVITE, ACK, CANCEL, OPTIONS, BYE\r\n"
                + "Max-Forwards: 70\r\n"
                + "Content-Length: 0\r\n"
                + "\r\n";

    	return message.getBytes("ASCII");
    }

    /** Register Message with (Proxy-)Authorization header 
     * @throws UnsupportedEncodingException */
    public byte[] registerAuth(String sipProviderhost, String mylocalIp, String branch, String userName, String tag, int cseq, String callid, String authPrefix, String realm, String nonce, String authresponse) throws UnsupportedEncodingException {
    	String message = "REGISTER sip:" + sipProviderhost + ":5060 SIP/2.0\r\n"
                + "Via:SIP/2.0/UDP " + mylocalIp + ":5780;branch=" + branch + ";rport\r\n"
                + "To: <sip:" + userName + "@" + sipProviderhost + ":5060>\r\n"
                + "From: <sip:" + userName + "@" + sipProviderhost + ":5060>;tag=" + tag + "\r\n"
                + "Call-ID: " + callid + "\r\n"
                + "CSeq: " + (cseq + 1) + " REGISTER\r\n"
                + "Contact: <sip:" + userName + "@" + mylocalIp + ":5780>\r\n"
                + "Expires: 3600\r\n"
                + "Supported: 100rel\r\n"
                + "Allow: INVITE, ACK, CANCEL, OPTIONS, BYE\r\n"
                + "Max-Forwards: 70\r\n"
                + "Content-Length: 0\r\n"
                + authPrefix + "Authorization: Digest username=\"" + userName + "\", realm=\"" + realm + "\", nonce=\"" 
  			    + nonce + "\", response=\"" + authresponse + "\", uri=\"sip:" + sipProviderhost + ":5060\", algorithm=MD5\r\n"
                + "\r\n";

    	return message.getBytes("ASCII");
    }

    /** UDP */
    public String sendUDP(String localip, String serverip, String username, String auth, String password, int port) {
        try {
        	// BRANCH ID always begin with the characters "z9hG4bK" and its next part must be unique.
        	// TAG contains a random string that was added by the phone.
        	// CALL-ID is the combination of a random string and the softphone's host name or IP address.  
        	// CSEQ contains an integer and a method name. The CSeq number is incremented for each new request.
        	String branch = "z9hG4bK"+randomString(13);
        	String tag = randomString(8);
        	String callid = randomString(8)+"@"+localip;

        	// Server inetaddress
        	InetAddress server = InetAddress.getByName(serverip);

	    	DatagramSocket socket = new DatagramSocket(5780, InetAddress.getByName(localip));
	    	socket.setSoTimeout(5000);

	    	// Register Message
	    	byte[] outData = registerMsg(serverip, localip, branch, username, tag, cseq, callid);
	    	DatagramPacket out = new DatagramPacket(outData, outData.length, server, port);
			socket.send(out);

			// Receive UDP
	    	byte[] inData = new byte[1024];
	    	DatagramPacket in = new DatagramPacket(inData, inData.length);
	    	socket.receive(in);
	    	String resp1 = new String(in.getData());

			// Get nonce and realm
			String nonce = getValues(resp1, "nonce=\"", "\"");
			String realm = getValues(resp1, "realm=\"", "\"");

			// Get Authorization type
	    	String authType = (resp1.toLowerCase().contains("407 Proxy Authentication Required".toLowerCase())) ? "Proxy-" : "";

			// MD5
			byte[] HA1 = (username + ":" + realm + ":" + password).getBytes();
			String strHA1 = getMD5Digest(HA1);
			byte[] HA2 = ("REGISTER:sip:" + serverip + ":5060").getBytes();
			String strHA2 = getMD5Digest(HA2);
			byte[] strHA = (strHA1 + ":" + nonce + ":" + strHA2).getBytes();
			String response = getMD5Digest(strHA);

			// New BRANCH and TAG
			String branch2 = "z9hG4bK"+randomString(13);

			// Register Message with Authorization
			byte[] outData2 = registerAuth(serverip, localip, branch2, username, tag, cseq, callid, authType, realm, nonce, response);
			DatagramPacket out2 = new DatagramPacket(outData2, outData2.length, server, 5060);
	    	socket.send(out2);
	    	cseq++;

			// Receive UDP
	    	byte[] inData2 = new byte[1024];
	    	DatagramPacket in2 = new DatagramPacket(inData2, inData2.length);
	    	socket.receive(in2);
	    	String resp2 = new String(in2.getData());

	    	// Response
	    	String result = new String();
	    	if(resp2.toLowerCase().contains("200 OK".toLowerCase())) result = "found";
	    	else if(resp2.toLowerCase().contains("Destination unreachable".toLowerCase())) result = "not found";
	    	else if(!resp2.equals("")) result = "invalid";

	    	socket.close();
	    	return result;
        }
        catch(Exception e) {
        	return "not found";
        }
    }

    /** First Screen */
    public void onCreate(Bundle savedInstanceState) {
    	// Screen resolution HEIGHT and WIDTH
    	height = height()[0];
    	width = height()[1];

        super.onCreate(savedInstanceState);

    	if(height < 321) setContentView(R.layout.activity_main0);
    	else if(height > 320 && height < 481) setContentView(R.layout.activity_main1);
    	else if(height > 480 && height < 960) setContentView(R.layout.activity_main2);
    	else if(height > 959 && height < 1025) setContentView(R.layout.activity_main4);
    	else setContentView(R.layout.activity_main3);
    }

    /** Start Button - Go to the Form page */
	public void start(View view) {
    	if(height < 321) setContentView(R.layout.activity_form0);
    	else if(height > 320 && height < 481) setContentView(R.layout.activity_form1);
    	else if(height > 480 && height < 854) setContentView(R.layout.activity_form2);
    	else if(height > 853 && height < 960) setContentView(R.layout.activity_form6);
    	else if(height > 959 && height < 1000) setContentView(R.layout.activity_form4);
    	else if(height > 999 && height < 1025) setContentView(R.layout.activity_form5);
    	else setContentView(R.layout.activity_form3);
	}

    /** Ok Button - Send UDP and determine the result: Found, Not Found or Invalid */
	public void ok(View view) {
    	// Username
        EditText uname = (EditText)findViewById(R.id.username);
        username = uname.getText().toString();
        // Authorization id
        EditText authid = (EditText)findViewById(R.id.auth);
        auth = authid.getText().toString();
        // Password
        EditText passwd = (EditText)findViewById(R.id.passwd);
        password = passwd.getText().toString();
        // PBX cime
        EditText proxy = (EditText)findViewById(R.id.proxy);
        pbx = proxy.getText().toString();
        // Local IP
        String ownIP = getLocalIpAddress();

        String result = sendUDP(ownIP, pbx, username, auth, password, 5060);
        cseq++;

        // Found -> activity_found
        if(result.equals("found")) {
				if(height < 321) setContentView(R.layout.activity_found0);
		    	else if(height > 320 && height < 481) setContentView(R.layout.activity_found1);
		    	else if(height > 480 && height < 960) setContentView(R.layout.activity_found2);
		    	else if(height > 959 && height < 1025) setContentView(R.layout.activity_found4);
		    	else setContentView(R.layout.activity_found3);
 		}
        // Found, but invalid username or password -> activity_invalid
        else if(result.equals("invalid")) {
				if(height < 321) setContentView(R.layout.activity_invalid0);
		    	else if(height > 320 && height < 481) setContentView(R.layout.activity_invalid1);
		    	else if(height > 480 && height < 960) setContentView(R.layout.activity_invalid2);
		    	else if(height > 959 && height < 1025) setContentView(R.layout.activity_invalid4);
		    	else setContentView(R.layout.activity_invalid3);
 		}
        // No VoIP service -> activity_not_found
        else {
        		if(height < 321) setContentView(R.layout.activity_not_found0);
		    	else if(height > 320 && height < 481) setContentView(R.layout.activity_not_found1);
		    	else if(height > 480 && height < 960) setContentView(R.layout.activity_not_found2);
		    	else if(height > 959 && height < 1025) setContentView(R.layout.activity_not_found4);
		    	else setContentView(R.layout.activity_not_found3);
        }
        
	}

    /** Back Button - Back to the Form page */
	public void back(View view) {
    	if(height < 321) setContentView(R.layout.activity_form0);
    	else if(height > 320 && height < 481) setContentView(R.layout.activity_form1);
    	else if(height > 480 && height < 854) setContentView(R.layout.activity_form2);
    	else if(height > 853 && height < 960) setContentView(R.layout.activity_form6);
    	else if(height > 959 && height < 1000) setContentView(R.layout.activity_form4);
    	else if(height > 999 && height < 1025) setContentView(R.layout.activity_form5);
    	else setContentView(R.layout.activity_form3);

    	// Username
    	EditText text1 = (EditText)findViewById(R.id.username);
    	text1.setText(username);
    	// Auhtorization ID
    	EditText text2 = (EditText)findViewById(R.id.auth);
    	text2.setText(auth);
    	// Password
    	EditText text3 = (EditText)findViewById(R.id.passwd);
    	text3.setText(password);
    	// IP PBX
    	EditText text4 = (EditText)findViewById(R.id.proxy);
    	text4.setText(pbx);
	}
}
